diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-assoc-manager.h ns-3.45/src/wifi/model/wifi-assoc-manager.h
--- ns-3.44/src/wifi/model/wifi-assoc-manager.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-assoc-manager.h	2025-06-01 20:34:45.626702300 -0700
@@ -200,6 +200,16 @@
     virtual bool CanBeReturned(const StaWifiMac::ApInfo& apInfo) const = 0;
 
     /**
+     * Check whether the channel width of the STA is compatible with the channel width of the
+     * operating channel of a given AP. A channel width is compatible if the STA can advertise it to
+     * the AP, or AP operates on a channel width that is equal or lower than that channel width
+     *
+     * @param apInfo the given AP information
+     * @return true if the channel width of the STA is compatible, false otherwise
+     */
+    bool IsChannelWidthCompatible(const StaWifiMac::ApInfo& apInfo) const;
+
+    /**
      * Extract the best AP to associate with from the sorted list and return
      * it, if any, to the STA wifi MAC along with the notification that scanning
      * is completed.
@@ -226,6 +236,9 @@
     std::set<uint8_t> m_allowedLinks; /**< "Only Beacon and Probe Response frames received on a
                                             link belonging to the this set are processed */
 
+    bool m_allowAssocAllChannelWidths; ///< flag whether the check on channel width compatibility
+                                       ///< with the candidate AP should be skipped
+
   private:
     /**
      * Start a scanning procedure. This method needs to schedule a call to
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-constants.cc ns-3.45/src/wifi/model/wifi-constants.cc
--- ns-3.44/src/wifi/model/wifi-constants.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/model/wifi-constants.cc	2025-06-01 20:34:45.626702300 -0700
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "wifi-constants.h"
+
+namespace ns3
+{
+
+const Time WIFI_TU = MicroSeconds(1024);
+
+const Time EMLSR_RX_PHY_START_DELAY = MicroSeconds(20);
+
+const Time OFDM_SIFS_TIME_20MHZ = MicroSeconds(16);
+
+const Time OFDM_SLOT_TIME_20MHZ = MicroSeconds(9);
+
+const Time OFDM_SIFS_TIME_10MHZ = MicroSeconds(32);
+
+const Time OFDM_SLOT_TIME_10MHZ = MicroSeconds(13);
+
+const Time OFDM_SIFS_TIME_5MHZ = MicroSeconds(64);
+
+const Time OFDM_SLOT_TIME_5MHZ = MicroSeconds(21);
+
+const Time DSSS_SIFS_TIME = MicroSeconds(10);
+
+const Time DSSS_SLOT_TIME = MicroSeconds(20);
+
+const Time MAX_PROPAGATION_DELAY = MicroSeconds(1);
+
+const Time MEDIUM_SYNC_THRESHOLD = MicroSeconds(72);
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-constants.h ns-3.45/src/wifi/model/wifi-constants.h
--- ns-3.44/src/wifi/model/wifi-constants.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/model/wifi-constants.h	2025-06-01 20:34:45.626702300 -0700
@@ -0,0 +1,130 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_CONSTANTS_H
+#define WIFI_CONSTANTS_H
+
+#include "ns3/nstime.h"
+
+/**
+ * @file
+ * @ingroup wifi
+ * Declaration of the constants used across wifi module
+ */
+
+namespace ns3
+{
+
+/// Wi-Fi Time Unit value in microseconds (see IEEE 802.11-2020 sec. 3.1)
+/// Used to initialize WIFI_TU
+extern const Time WIFI_TU;
+
+/// aRxPHYStartDelay value to use when waiting for a new frame in the context of EMLSR operations
+/// (Sec. 35.3.17 of 802.11be D3.1)
+extern const Time EMLSR_RX_PHY_START_DELAY;
+
+/// aSIFSTime value for OFDM (20 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SIFS_TIME_20MHZ;
+
+/// aSlotTime duration for OFDM (20 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SLOT_TIME_20MHZ;
+
+/// aSIFSTime value for OFDM (10 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SIFS_TIME_10MHZ;
+
+/// aSlotTime duration for OFDM (10 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SLOT_TIME_10MHZ;
+
+/// aSIFSTime value for OFDM (5 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SIFS_TIME_5MHZ;
+
+/// aSlotTime duration for OFDM (5 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SLOT_TIME_5MHZ;
+
+/// aSIFSTime duration for DSSS (Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2020)
+extern const Time DSSS_SIFS_TIME;
+
+/// aSlotTime duration for DSSS (Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2020)
+extern const Time DSSS_SLOT_TIME;
+
+/// maximum propagation delay
+extern const Time MAX_PROPAGATION_DELAY;
+
+/// The aMediumSyncThreshold defined by Sec. 35.3.16.18.1 of 802.11be D4.0
+extern const Time MEDIUM_SYNC_THRESHOLD;
+
+/// Subcarrier frequency spacing in Hz (Table 19-6 "Timing-related constants" of 802.11-2020)
+static constexpr uint32_t SUBCARRIER_FREQUENCY_SPACING{312500};
+
+/// Subcarrier frequency spacing for the HE modulated fields in Hz (Table 27-12 "Timing-related
+/// constants" of 802.11ax-2021)
+static constexpr uint32_t SUBCARRIER_FREQUENCY_SPACING_HE{78125};
+
+/// Size of the space of sequence numbers
+static constexpr uint16_t SEQNO_SPACE_SIZE{4096};
+
+/// Size of the half the space of sequence numbers (used to determine old packets)
+static constexpr uint16_t SEQNO_SPACE_HALF_SIZE{SEQNO_SPACE_SIZE / 2};
+
+/// This value conforms to the 802.11 specification
+static constexpr uint16_t MAX_MSDU_SIZE{2304};
+
+/// The length in octets of the IEEE 802.11 MAC FCS field
+static constexpr uint16_t WIFI_MAC_FCS_LENGTH{4};
+
+/// The minimum value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MIN_RTS_THRESHOLD{0};
+
+/// The maximum value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MAX_RTS_THRESHOLD{4692480};
+
+/// The default value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_DEFAULT_RTS_THRESHOLD{WIFI_MAX_RTS_THRESHOLD};
+
+/// The minimum value for dot11FragmentationThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MIN_FRAG_THRESHOLD{256};
+
+/// The maximum value for dot11FragmentationThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MAX_FRAG_THRESHOLD{65535};
+
+/// The default value for dot11FragmentationThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_DEFAULT_FRAG_THRESHOLD{WIFI_MAX_FRAG_THRESHOLD};
+
+/// STA_ID to identify a single user (SU)
+static constexpr uint16_t SU_STA_ID{65535};
+
+/// Empty 242-tone RU identifier for HE (Section 26.11.7 802.11ax-2021)
+static constexpr uint8_t EMPTY_242_TONE_HE_RU{113};
+
+/// The minimum value for the association ID (Sec. 9.4.1.8 of 802.11-2020)
+static constexpr uint16_t MIN_AID{1};
+
+/// The maximum value for the association ID (Sec. 9.4.1.8 of 802.11-2020)
+static constexpr uint16_t MAX_AID{2007};
+
+/// STA_ID for a RU that is intended for no user (Section 26.11.1 802.11ax-2021)
+static constexpr uint16_t NO_USER_STA_ID{2046};
+
+/// Unassigned 242-tone RU identifier for EHT (Table Table 36-34 IEEE 802.11be D7.0)
+static constexpr uint8_t UNASSIGNED_242_TONE_EHT_RU{27};
+
+/// The maximum value for the association ID updated since 802.11be (Sec. 9.4.1.8 of 802.11be D7.0)
+static constexpr uint16_t EHT_MAX_AID{2006};
+
+/// AID value for Special User Info field in trigger frames (Sec. 9.3.1.22.3 of 802.11be D7.0)
+static constexpr uint16_t AID_SPECIAL_USER{2007};
+
+} // namespace ns3
+
+#endif /* WIFI_CONSTANTS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-default-ack-manager.cc ns-3.45/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.44/src/wifi/model/wifi-default-ack-manager.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-default-ack-manager.cc	2025-06-01 20:34:45.626702300 -0700
@@ -703,7 +703,10 @@
         acknowledgment->stationsReplyingWithBlockAck.emplace(
             receiver,
             WifiDlMuAggregateTf::BlockAckInfo{
-                GetMuBarSize({m_mac->GetBarTypeAsOriginator(receiver, tid)}),
+                GetMuBarSize(IsEht(txParams.m_txVector.GetPreambleType()) ? TriggerFrameVariant::EHT
+                                                                          : TriggerFrameVariant::HE,
+                             txParams.m_txVector.GetChannelWidth(),
+                             {m_mac->GetBarTypeAsOriginator(receiver, tid)}),
                 edca->GetBaManager()->GetBlockAckReqHeader(
                     mpdu->GetOriginal()->GetHeader().GetAddr1(),
                     tid),
@@ -754,7 +757,10 @@
                 NS_LOG_INFO("Unallocated RU");
                 continue;
             }
-            NS_ABORT_MSG_IF(aid12 == 0 || aid12 > 2007, "Allocation of RA-RUs is not supported");
+            const auto maxAid =
+                IsEht(txParams.m_txVector.GetPreambleType()) ? EHT_MAX_AID : MAX_AID;
+            NS_ABORT_MSG_IF(aid12 < MIN_AID || aid12 > maxAid,
+                            "Allocation of RA-RUs is not supported");
 
             const auto it = apMac->GetStaList(m_linkId).find(aid12);
             NS_ASSERT(it != apMac->GetStaList(m_linkId).end());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-default-assoc-manager.cc ns-3.45/src/wifi/model/wifi-default-assoc-manager.cc
--- ns-3.44/src/wifi/model/wifi-default-assoc-manager.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-default-assoc-manager.cc	2025-06-01 20:34:45.627702200 -0700
@@ -13,6 +13,7 @@
 #include "wifi-net-device.h"
 #include "wifi-phy.h"
 
+#include "ns3/boolean.h"
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 #include "ns3/vht-configuration.h"
@@ -40,7 +41,16 @@
                           "notified within this amount of time, we give up setting up that link.",
                           TimeValue(MilliSeconds(5)),
                           MakeTimeAccessor(&WifiDefaultAssocManager::m_channelSwitchTimeout),
-                          MakeTimeChecker(Seconds(0)));
+                          MakeTimeChecker(Seconds(0)))
+            .AddAttribute(
+                "SkipAssocIncompatibleChannelWidth",
+                "If set to true, it does not include APs with incompatible channel width with the "
+                "STA in the list of candidate APs. An incompatible channel width is one that the "
+                "STA cannot advertise to the AP, unless AP operates on a channel width that is "
+                "equal or lower than that channel width.",
+                BooleanValue(false),
+                MakeBooleanAccessor(&WifiDefaultAssocManager::m_skipAssocIncompatibleChannelWidth),
+                MakeBooleanChecker());
     return tid;
 }
 
@@ -206,13 +216,13 @@
                     // switching channel while a PHY is in sleep state fails
                     phy->ResumeFromSleep();
                 }
-                // switch this link to using the channel used by a reported AP (or its primary80
-                // in case the reported AP is using a 160 MHz and the non-AP MLD does not support
-                // 160 MHz operations)
-                if (apChannel.GetTotalWidth() > MHz_u{80} &&
-                    !phy->GetDevice()->GetVhtConfiguration()->m_160MHzSupported)
+
+                // switch this link to using the channel used by a reported AP (or one of its
+                // primary subchannels in case the reported AP has larger channel width than the one
+                // supported by the non-AP MLD)
+                if (apChannel.GetTotalWidth() > phy->GetChannelWidth())
                 {
-                    apChannel = apChannel.GetPrimaryChannel(MHz_u{80});
+                    apChannel = apChannel.GetPrimaryChannel(phy->GetChannelWidth());
                 }
 
                 NS_LOG_DEBUG("Switch link " << +linkId << " to using " << apChannel);
@@ -290,7 +300,8 @@
 bool
 WifiDefaultAssocManager::CanBeInserted(const StaWifiMac::ApInfo& apInfo) const
 {
-    return (m_waitBeaconEvent.IsPending() || m_probeRequestEvent.IsPending());
+    return ((m_waitBeaconEvent.IsPending() || m_probeRequestEvent.IsPending()) &&
+            (!m_skipAssocIncompatibleChannelWidth || IsChannelWidthCompatible(apInfo)));
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-default-assoc-manager.h ns-3.45/src/wifi/model/wifi-default-assoc-manager.h
--- ns-3.44/src/wifi/model/wifi-default-assoc-manager.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-default-assoc-manager.h	2025-06-01 20:34:45.627702200 -0700
@@ -57,9 +57,11 @@
      */
     void ChannelSwitchTimeout(uint8_t linkId);
 
-    EventId m_waitBeaconEvent;   ///< wait beacon event
-    EventId m_probeRequestEvent; ///< probe request event
-    Time m_channelSwitchTimeout; ///< maximum delay for channel switching
+    EventId m_waitBeaconEvent;                ///< wait beacon event
+    EventId m_probeRequestEvent;              ///< probe request event
+    Time m_channelSwitchTimeout;              ///< maximum delay for channel switching
+    bool m_skipAssocIncompatibleChannelWidth; ///< flag whether to skip APs with incompatible
+                                              ///< channel width
 
     /** Channel switch info */
     struct ChannelSwitchInfo
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-default-protection-manager.cc ns-3.45/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.44/src/wifi/model/wifi-default-protection-manager.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-default-protection-manager.cc	2025-06-01 20:34:45.627702200 -0700
@@ -291,6 +291,24 @@
             // PE Disambiguity, UL Spatial Reuse, Doppler and UL HE-SIG-A2 Reserved subfields in
             // the Common Info field are reserved. (Sec. 9.3.1.22.5 of 802.11ax)
             protection->muRts.SetType(TriggerFrameType::MU_RTS_TRIGGER);
+            /* 35.2.2.1 MU-RTS Trigger frame transmission (IEEE P802.11be/D7.0):
+             * If a non-AP EHT STA is addressed in an MU-RTS Trigger frame from an EHT AP and any of
+             * the following conditions is met, the User Info field addressed to an EHT STA in the
+             * MU-RTS Trigger frame shall be an EHT variant User Info field:
+             * - The bandwidth of the EHT MU PPDU or non-HT duplicate PPDU carrying the MU-RTS
+             * Trigger frame is 320 MHz.
+             * - The EHT MU PPDU or non-HT duplicate PPDU carrying the MU-RTS Trigger frame is
+             * punctured. Otherwise, the EHT AP may decide whether the User Info field in the MU-RTS
+             * Trigger frame is an HE variant User Info field or an EHT variant User Info field.
+             */
+            const auto& inactiveSubchannels = txParams.m_txVector.GetInactiveSubchannels();
+            const auto isPunctured =
+                std::find(inactiveSubchannels.cbegin(), inactiveSubchannels.cend(), true) !=
+                inactiveSubchannels.cend();
+            const auto muRtsVariant = ((txWidth == MHz_u{320}) || isPunctured)
+                                          ? TriggerFrameVariant::EHT
+                                          : TriggerFrameVariant::HE;
+            protection->muRts.SetVariant(muRtsVariant);
             protection->muRts.SetUlBandwidth(txWidth);
 
             // Add a User Info field for each of the receivers already in the TX params
@@ -351,6 +369,7 @@
     // PE Disambiguity, UL Spatial Reuse, Doppler and UL HE-SIG-A2 Reserved subfields in
     // the Common Info field are reserved. (Sec. 9.3.1.22.5 of 802.11ax)
     protection->muRts.SetType(TriggerFrameType::MU_RTS_TRIGGER);
+    protection->muRts.SetVariant(trigger.GetVariant());
     protection->muRts.SetUlBandwidth(txWidth);
 
     NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-information-element.cc ns-3.45/src/wifi/model/wifi-information-element.cc
--- ns-3.44/src/wifi/model/wifi-information-element.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-information-element.cc	2025-06-01 20:34:45.627702200 -0700
@@ -123,7 +123,7 @@
     Buffer::Iterator start = i;
     i = DeserializeIfPresent(i);
     // This IE was not optional, so confirm that we did actually
-    // deserialise something.
+    // deserialize something.
     NS_ASSERT(i.GetDistanceFrom(start) != 0);
     return i;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-information-element.h ns-3.45/src/wifi/model/wifi-information-element.h
--- ns-3.44/src/wifi/model/wifi-information-element.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-information-element.h	2025-06-01 20:34:45.627702200 -0700
@@ -262,7 +262,7 @@
  * maintain the relevant state.
  *
  * This class also provides an implementation of the equality
- * operator, which operates by comparing the serialised versions of
+ * operator, which operates by comparing the serialized versions of
  * the two WifiInformationElement objects concerned.
  *
  * Elements are defined to have a common general format consisting of
@@ -347,7 +347,7 @@
     virtual void Print(std::ostream& os) const;
     /**
      * Compare two IEs for equality by ID & Length, and then through
-     * memcmp of serialised version
+     * memcmp of serialized version
      *
      * @param a another information element to compare with
      *
